Documentation Index
Fetch the complete documentation index at: https://cdktn.io/docs/llms.txt
Use this file to discover all available pages before exploring further.
Initializers
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;
DataTerraformRemoteStateGcs.Builder.create(Construct scope, java.lang.String id)
// .defaults(java.util.Map<java.lang.String, java.lang.Object>)
// .workspace(java.lang.String)
.bucket(java.lang.String)
// .accessToken(java.lang.String)
// .credentials(java.lang.String)
// .encryptionKey(java.lang.String)
// .impersonateServiceAccount(java.lang.String)
// .impersonateServiceAccountDelegates(java.util.List<java.lang.String>)
// .kmsEncryptionKey(java.lang.String)
// .prefix(java.lang.String)
// .storeageCustomEndpoint(java.lang.String)
.build();
| Name | Type | Description |
|---|
scope | software.constructs.Construct | No description. |
id | java.lang.String | No description. |
defaults | java.util.Map< java.lang.String, java.lang.Object > | No description. |
workspace | java.lang.String | No description. |
bucket | java.lang.String | (Required) The name of the GCS bucket. |
accessToken | java.lang.String | (Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field. |
credentials | java.lang.String | (Optional) Local path to Google Cloud Platform account credentials in JSON format. |
encryptionKey | java.lang.String | (Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state. |
impersonateServiceAccount | java.lang.String | (Optional) The service account to impersonate for accessing the State Bucket. |
impersonateServiceAccountDelegates | java.util.List< java.lang.String > | (Optional) The delegation chain for an impersonating a service account. |
kmsEncryptionKey | java.lang.String | (Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket. |
prefix | java.lang.String | (Optional) GCS prefix inside the bucket. |
storeageCustomEndpoint | java.lang.String | (Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b). |
scopeRequired
- Type: software.constructs.Construct
idRequired
defaultsOptional
- Type: java.util.Map< java.lang.String, java.lang.Object >
workspaceOptional
bucketRequired
(Required) The name of the GCS bucket.
This name must be globally unique.
accessTokenOptional
(Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field.
credentialsOptional
(Optional) Local path to Google Cloud Platform account credentials in JSON format.
If unset, Google Application Default Credentials are used.
The provided credentials must have Storage Object Admin role on the bucket.
Warning: if using the Google Cloud Platform provider as well,
it will also pick up the GOOGLE_CREDENTIALS environment variable.
encryptionKeyOptional
(Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state.
impersonateServiceAccountOptional
(Optional) The service account to impersonate for accessing the State Bucket.
You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed.
If you are using a delegation chain, you can specify that using the impersonate_service_account_delegates field.
Alternatively, this can be specified using the GOOGLE_IMPERSONATE_SERVICE_ACCOUNT environment variable.
impersonateServiceAccountDelegatesOptional
- Type: java.util.List< java.lang.String >
(Optional) The delegation chain for an impersonating a service account.
kmsEncryptionKeyOptional
(Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket.
Format should be projects/{{project}}/locations/{{location}}/keyRings/{{keyRing}}/cryptoKeys/{{name}}.
For more information, including IAM requirements, see Customer-managed Encryption Keys.
prefixOptional
(Optional) GCS prefix inside the bucket.
Named states for workspaces are stored in an object called < prefix >/< name >.tfstate.
storeageCustomEndpointOptional
(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b).
See here for more details
Methods
| Name | Description |
|---|
toString | Returns a string representation of this construct. |
addOverride | No description. |
overrideLogicalId | Overrides the auto-generated logical ID with a specific ID. |
resetOverrideLogicalId | Resets a previously passed logical Id to use the auto-generated logical id again. |
toHclTerraform | Adds this resource to the terraform JSON output. |
toMetadata | No description. |
toTerraform | Adds this resource to the terraform JSON output. |
get | No description. |
getBoolean | No description. |
getList | No description. |
getNumber | No description. |
getString | No description. |
toString
public java.lang.String toString()
Returns a string representation of this construct.
addOverride
public void addOverride(java.lang.String path, java.lang.Object value)
pathRequired
valueRequired
overrideLogicalId
public void overrideLogicalId(java.lang.String newLogicalId)
Overrides the auto-generated logical ID with a specific ID.
newLogicalIdRequired
The new logical ID to use for this stack element.
resetOverrideLogicalId
public void resetOverrideLogicalId()
Resets a previously passed logical Id to use the auto-generated logical id again.
public java.lang.Object toHclTerraform()
Adds this resource to the terraform JSON output.
public java.lang.Object toMetadata()
public java.lang.Object toTerraform()
Adds this resource to the terraform JSON output.
get
public IResolvable get(java.lang.String output)
outputRequired
getBoolean
public IResolvable getBoolean(java.lang.String output)
outputRequired
getList
public java.util.List<java.lang.String> getList(java.lang.String output)
outputRequired
getNumber
public java.lang.Number getNumber(java.lang.String output)
outputRequired
getString
public java.lang.String getString(java.lang.String output)
outputRequired
Static Functions
| Name | Description |
|---|
isConstruct | Checks if x is a construct. |
isTerraformElement | No description. |
isConstruct
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;
DataTerraformRemoteStateGcs.isConstruct(java.lang.Object x)
Checks if x is a construct.
Use this method instead of instanceof to properly detect Construct
instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on
disk are seen as independent, completely different libraries. As a
consequence, the class Construct in each copy of the constructs library
is seen as a different class, and an instance of one class will not test as
instanceof the other class. npm install will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the constructs
library can be accidentally installed, and instanceof will behave
unpredictably. It is safest to avoid using instanceof, and using
this type-testing method instead.
xRequired
Any object.
import io.cdktn.cdktn.DataTerraformRemoteStateGcs;
DataTerraformRemoteStateGcs.isTerraformElement(java.lang.Object x)
xRequired
Properties
| Name | Type | Description |
|---|
node | software.constructs.Node | The tree node. |
cdktfStack | TerraformStack | No description. |
fqn | java.lang.String | No description. |
friendlyUniqueId | java.lang.String | No description. |
nodeRequired
- Type: software.constructs.Node
The tree node.
cdktfStackRequired
public TerraformStack getCdktfStack();
fqnRequired
public java.lang.String getFqn();
friendlyUniqueIdRequired
public java.lang.String getFriendlyUniqueId();
Constants
| Name | Type | Description |
|---|
tfResourceType | java.lang.String | No description. |
tfResourceTypeRequired
public java.lang.String getTfResourceType();